' IndexSolveCL.bas for FilmStar DESIGN
' Based on IndexSolve.bas, uses Spectra Collector
' Uses new Function CRcell and Sub CRinfo
' Copyright 2018 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
DefInt i-n
DefSng a-h, o-z

' Index fit at series of measured wavelengths at different
' angles and polarizations using Index Function $NK
'
' ***********************  Initial Values ***********************
' ********************** Change as Required *********************
' Click Spectra..Sort in the Collector to change wavelength order
Const xnstart = .2
Const xkstart = 5
Const IndexRow = 3   ' Film Indices $NK function row #
Const nSheets = 2    ' # sheets in Spectra Collector
' ***************************************************************
Option Base 1
Option Explicit

Sub Main
    Const tol$ = "1"    ' Tolerance
    Dim iSheet, iWave, jCol, nRows&, nCols, clip$
    Dim trg$, hdr$
    OptiVars "-" & CStr(IndexRow)   ' specify variable
    MainActivate: AxesDraw
    CLinfo nRows, nCols, 1
    If nRows = 0 Then End   ' Collector not open
    SetIndexCoeff IndexRow, 1, xnstart   ' starting index values
    SetIndexCoeff IndexRow, 2, xkstart
    For iWave = 1 To nRows-1
        trg$ = ""
        For iSheet% = 1 To nSheets
            CLinfo nRows, nCols, iSheet
            If nRows = 0 Then GoTo TargPaste     ' no more worksheets
            For jCol = 2 To nCols
                hdr$ = CLcell(1, jCol, iSheet)   ' header row
                Select Case Left$(hdr$, 1)
                Case "T"
                    trg$ = trg$ & " % Trns"
                Case "R"
                    trg$ = trg$ & " % Refl"
                End Select
                trg$ = trg$ & vbTab & CStr(CLcell(iWave+1, 1, iSheet)) & vbTab & _
                  CStr(CLcell(iWave+1, jCol, iSheet)) & vbTab & tol$ & vbTab & _
                  Mid$(hdr$, 4) & vbTab & " " & Mid$(hdr$, 2, 1) & vbCrLf
            Next jCol
        Next iSheet
TargPaste:
        TargetsPaste trg$
        Optimize
        clip$ = clip$ & CLcell(iWave+1, 1, 1) & vbTab & Format$(IndexCoeff(IndexRow,1)) _
          & vbTab & Format(IndexCoeff(IndexRow,2)) & vbCrLf
    Next iWave
    Clipboard clip$
    Busy False
    MsgBox "Index table copied to clipboard", vbOK ,"n,k Calculation"
End Sub

